require 'sylvilagus/init'

require 'rabbitmq-client.jar'
import com.rabbitmq.client.ConnectionFactory

module Sylvilagus
  module Ch02
    class HelloWorldProducer
      class << self
        def main
          message = ARGV.first || 'snorg'

          factory = ConnectionFactory.new
          factory.setUri('amqp://guest:guest@localhost:5672')
          conn = factory.newConnection
          channel = conn.createChannel
          channel.exchangeDeclare('hello-exchange', 'direct', true)
          channel.queueDeclare('hello-queue', false, false, false, nil)

          channel.basicPublish('hello-exchange', 'hola', nil, message.to_java_bytes)
          puts "Published #{message.inspect}"
        ensure
          conn.close
        end
      end
    end
  end
end

if $0 == __FILE__
  Sylvilagus::Ch02::HelloWorldProducer.main
end
